﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Agora.Model.ImageAnalysis;

namespace Agora.Model.OperatorLevel0
{
    public class COperatorDelete : COperator
    {
        protected bool _Recurse = false;

        public COperatorDelete(CPattern pattern, bool recursionOn)
            : base(pattern)
        {
            _Recurse = recursionOn;
        }

        protected override bool EvaluatePairing()
        {
            return true;
        }

        protected override void UpdateGraph()
        {
            LinkedListNode<CEOC> rootPattern = Pattern.Graph.Root;
            LinkedListNode<CEOC> childPattern = rootPattern.Value.Childs.First;
            if (childPattern == null)
            {
                throw new Exception("COperatorDelete : cannot UpdateGraph using zero-child pattern");
            }
            LinkedListNode<CEOC> parentGraph = rootPattern.Value.PairedWith;
            LinkedListNode<CEOC> childGraph = childPattern.Value.PairedWith;
            if (_Recurse == false)
            {
                // Add all childs of node to remove to its parent:
                LinkedListNode<CEOC> y = childGraph.Value.Childs.First;
                while (y != null)
                {
                    childGraph.Value.RemoveChild(y);
                    parentGraph.Value.AddChild(y);
                    // BUG !!! y = y.Next;
                    y = childGraph.Value.Childs.First;
                }
            }
            // finally, remove node and update parent's features
            parentGraph.Value.RemoveChild(childGraph);
            parentGraph.Value.ComputeFeatures();
        }
    }
}
