﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Agora.Model.ImageAnalysis;

namespace Agora.Model.OperatorLevel0
{
    public class COperatorSetFeatures : COperator
    {
        public COperatorSetFeatures(CPattern p)
            : base(p)
        {
        }

        protected override bool EvaluatePairing()
        {
            LinkedListNode<CEOC> rootPattern = Pattern.Graph.Root;
            LinkedListNode<CEOC> childPattern = rootPattern.Value.Childs.First;
            CEOC childGraph = childPattern.Value.PairedWithCandidate.Value;
            bool result = CFeatureMode.CompareArrays(childGraph.FeatureModes, this.FeatureModes);
            // Return false if the 2 array are identical, which
            // means that SetFeatures is already made,
            // then we will have no subsequent UpdateGraph() to do
            return ! result;
        }

        protected override void UpdateGraph()
        {
            LinkedListNode<CEOC> rootPattern = Pattern.Graph.Root;
            LinkedListNode<CEOC> childPattern = rootPattern.Value.Childs.First;
            CEOC childGraph = childPattern.Value.PairedWith.Value;
            childGraph.FeatureModes = CFeatureMode.CloneArray(this.FeatureModes);
            childGraph.ComputeFeatures();
        }
    }
}
