﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Agora.Model.ImageAnalysis;

namespace Agora.Model.OperatorMisc
{
    public class CCreateLabel : Agora.Model.Project.CStepOperator
    {
        private int _EOCType = 0;
        public int EOCType
        {
            get { return _EOCType; }
            set { _EOCType = value; }
        }
        private string _EOCTypeName = "";
        public string EOCTypeName
        {
            get { return _EOCTypeName; }
            set { _EOCTypeName = value; }
        }

        public CCreateLabel()
        {
        }
        public CCreateLabel(string name)
        {
            _EOCTypeName = name.ToUpper();
        }
        public CCreateLabel(int type, string name)
        {
            _EOCType = type;
            _EOCTypeName = name.ToUpper();
        }

        public override Agora.Model.Project.CStepOperator Clone()
        {
            return new CCreateLabel(_EOCType, _EOCTypeName.ToUpper());
        }
        public override bool Apply(CImageAnalysis analysis)
        {
            string name = new StackTrace().GetFrame(0).GetMethod().ReflectedType.Name;
            Trace.WriteLine("Create label " + _EOCTypeName + "... ", name);
            _EOCTypeName = _EOCTypeName.ToUpper();
            if (_EOCType != 0)
            {
                analysis.CreateEOCType(_EOCType, _EOCTypeName);
            }
            else
            {
                analysis.CreateEOCType(_EOCTypeName);
                _EOCType = analysis.GetEOCTypeByName(_EOCTypeName).Type;
            }
            Trace.WriteLine("OK.", name);
            return true;
        }
        /*
        public override bool Undo(CImageAnalysis analysis)
        {
            CEOCType type;
            type = analysis.GetEOCTypeByID(_EOCType);
            analysis.DeleteEOCType(type);
            return true;
        }
        */
        public override string ToString()
        {
            return "CreateLabel:" +
                "Type=" + EOCTypeName;
        }
    }
}
