﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

using Agora.Model.ImageAnalysis;

namespace Agora.Model.Project
{

    public class CScenarioStep
    {
        private CStepOperator _Operator = null;
        
        /*
        [XmlElement("Delete", typeof(OperatorLevel1.CDelete))]
        [XmlElement("FindCC", typeof(OperatorLevel1.CFindCC))]
        [XmlElement("Insert", typeof(OperatorLevel1.CInsert))]
        [XmlElement("SetPointMode", typeof(OperatorLevel1.CSetPointMode))]
        [XmlElement("Classify", typeof(OperatorLevel2.CClassifyByFeatures))]
        [XmlElement("DeleteIncludedEOC", typeof(OperatorLevel2.CDeleteIncludedEOC))]
        [XmlElement("Fusion", typeof(OperatorLevel2.CFusion))]
        [XmlElement("CreateLabel", typeof(OperatorMisc.CCreateLabel))]
        [XmlElement("ExportResults", typeof(OperatorMisc.CExportResults))]
        */
        public CStepOperator Operator
        {
            get { return _Operator; }
            set { _Operator = value; }
        }

        private CImageAnalysis _BeforeApply = null;
        [XmlIgnore]
        public CImageAnalysis BeforeApply
        {
            get { return _BeforeApply; }
            set { _BeforeApply = value; }
        }

        private CImageAnalysis _AfterApply = null;
        [XmlIgnore]
        public CImageAnalysis AfterApply
        {
            get { return _AfterApply; }
            set { _AfterApply = value; }
        }

        /// <summary>
        /// For XML Serialization only !
        /// </summary>
        public CScenarioStep()
        {
        }

        public CScenarioStep(CStepOperator op)
        {
            _Operator = op;
        }

        public void SetAnalysis(CImageAnalysis a)
        {
            _BeforeApply = a;
        }

        public CImageAnalysis Apply()
        {
            AfterApply = BeforeApply.Clone();
            _Operator.Apply(AfterApply);
            return AfterApply;
        }
        public CImageAnalysis Undo()
        {
            return BeforeApply;
        }
        public override string ToString()
        {
            return _Operator.ToString();
        }
    }
}
