﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Diagnostics;

namespace Agora.Model.Utils
{
    public class CCache
    {
        private string _Directory;

        public CCache(string filename)
        {
            // create main cache directory
            //string mainDir = AppDomain.CurrentDomain.BaseDirectory + "/_CACHE";
            string mainDir = GLOBALDATA.ProjectDirectory + "/_CACHE";
            if (!Directory.Exists(mainDir))
            {
                Directory.CreateDirectory(mainDir);
            }
            // create one subdir per image
            string dir = Path.GetFileNameWithoutExtension(filename);
            _Directory = mainDir + "/" + dir;
            if (!Directory.Exists(_Directory))
            {
                Directory.CreateDirectory(_Directory);
            }
        }

        public void Clean()
        {
            foreach (string f in Directory.GetFiles(_Directory))
            {
                File.Delete(f);
            }
        }

        public bool Exist(string id)
        {
            string filename = _Directory + "/" + id + "." + GLOBALDATA.IMAGE_OUTPUT_FILE_EXT;
            if (File.Exists(filename))
            {
                return (true);
            }
            else
            {
                return false;
            }
        }

        public Bitmap LoadFromCache(string id)
        {
            Bitmap img;
            string filename = _Directory + "/" + id + "." + GLOBALDATA.IMAGE_OUTPUT_FILE_EXT;
            img = new Bitmap(filename);
            return img;
        }

        public void StoreInCache(string id, Bitmap img)
        {
            string filename = _Directory + "/" + id + "." + GLOBALDATA.IMAGE_OUTPUT_FILE_EXT;
            img.Save(filename, ImageFormat.Png);
        }
    }
}
