﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Agora.Model.ImageAnalysis;

namespace Agora.Model.Utils
{
    public class CBFS
    {
        private Queue<CEOC> _BfsVertices = null;
        public CBFS()
        {
            _BfsVertices = new Queue<CEOC>();
        }
        public void Start(CEOC v)
        {
            _BfsVertices.Clear();
            _BfsVertices.Enqueue(v);
        }

        private void EnqueueAllChilds(CEOC v)
        {
            for (LinkedListNode<CEOC> w = v.Childs.First; w != null; w = w.Next)
            {
                _BfsVertices.Enqueue(w.Value);
            }
        }

        public CEOC GetNext()
        {
            if (_BfsVertices.Count <= 0)
                return null;
            CEOC v = _BfsVertices.Dequeue();
            this.EnqueueAllChilds(v);
            return v;
        }
    }

    public class CGraph
    {
        private LinkedListNode<CEOC> _Root = null;
        public LinkedListNode<CEOC> Root
        {
            get { return _Root; }
            set { _Root = value; }
        }

        public CGraph()
        {
        }

        public CGraph Clone()
        {
            CGraph result = new CGraph();
            CEOC root = this.GetRoot().Clone();
            result.SetRoot(root);
            return result;
        }

        public void SetRoot(CEOC root)
        {
            _Root = new LinkedListNode<CEOC>(root);
            root.Node = _Root;
        }
        public CEOC GetRoot()
        {
            return _Root.Value;
        }
    }
}
