﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Agora.Model.ImageAnalysis;
using Agora.Model.Utils;
using Agora.Model.OperatorLevel0;
using Agora.Model.OperatorLevel0.Pairing;
using Agora.Model.OperatorLevel1;

namespace GUI.L1Operations
{
    public partial class Delete : Form
    {
        /// <summary>
        /// Properties to set before showing form
        /// </summary>
        public List<string> Labels { get; set; }

        /// <summary>
        /// Properties to get after closing form
        /// </summary>
        public Agora.Model.OperatorLevel1.CDelete Operator { get; set; }

        public Delete()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.None;
            Labels = new List<string>();
        }

        private void SetDefaultPropertiesValues()
        {
            Operator.EOCTypeChild = this.Labels[0];
            Operator.EOCTypeParent = this.Labels[0];
            Operator.DeleteAll = false;
        }

        private void SetControlsValues()
        {
            // Labels
            CFormUtilities.SetComboBoxLabel(cbEocToDeleteLabel, Labels, Operator.EOCTypeChild);
            CFormUtilities.SetComboBoxLabel(cbParentLabel, Labels, Operator.EOCTypeParent);

            // Checkboxes
            checkRecurse.Checked = Operator.DeleteAll;
        }

        private void cbParentLabel_SelectedIndexChanged(object sender, EventArgs e)
        {
            Operator.EOCTypeParent = String.Copy(cbParentLabel.SelectedItem.ToString());
        }

        private void cbEocToDeleteLabel_SelectedIndexChanged(object sender, EventArgs e)
        {
            Operator.EOCTypeChild = String.Copy(cbEocToDeleteLabel.SelectedItem.ToString());
        }

        private void checkRecurse_CheckedChanged(object sender, EventArgs e)
        {
            Operator.DeleteAll = checkRecurse.Checked;
        }

        private void Delete_Shown(object sender, EventArgs e)
        {
            if (Operator.EOCTypeChild == null) SetDefaultPropertiesValues();
            if (Operator.EOCTypeParent == null) SetDefaultPropertiesValues();
            this.SetControlsValues();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;

            // Labels : set by Combobox event

            // Flags : set by checkbox event

            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}
