﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Agora.Model.ImageAnalysis;
using Agora.Model.OperatorLevel0;
using Agora.Model.OperatorLevel0.Pairing;
using Agora.Model.OperatorLevel1;

namespace GUI.L1Operations
{
    public partial class FeatureMatrixComparator : Form
    {
        /// <summary>
        /// Properties to set before showing form
        /// </summary>
        public string DimensionName { get;  set; }

        /// <summary>
        /// Properties to set/get
        /// </summary>
        public CFeatureMatrixComparator Matrix { get; set; }


        public FeatureMatrixComparator()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.None;
            Matrix = new CFeatureMatrixComparator();
            DimensionName = "";
        }

        private void SetControlsValues()
        {
            labelFeatureName.Text = DimensionName;
            /*
            cba0a1.Checked = Matrix.ComparisonMatrix[0][0].SignedDistance;
            cba0b1.Checked = Matrix.ComparisonMatrix[0][1].SignedDistance;
            cbb0a1.Checked = Matrix.ComparisonMatrix[1][0].SignedDistance;
            cbb0b1.Checked = Matrix.ComparisonMatrix[1][1].SignedDistance;
            tba0a1.Text = Matrix.ComparisonMatrix[0][0].MaxDistance.ToString();
            tba0b1.Text = Matrix.ComparisonMatrix[0][1].MaxDistance.ToString();
            tbb0a1.Text = Matrix.ComparisonMatrix[1][0].MaxDistance.ToString();
            tbb0b1.Text = Matrix.ComparisonMatrix[1][1].MaxDistance.ToString();
            */
            cba0a1.Checked = Matrix.a0a1.SignedDistance;
            cba0b1.Checked = Matrix.a0b1.SignedDistance;
            cbb0a1.Checked = Matrix.b0a1.SignedDistance;
            cbb0b1.Checked = Matrix.b0b1.SignedDistance;
            tba0a1.Text = Matrix.a0a1.MaxDistance.ToString();
            tba0b1.Text = Matrix.a0b1.MaxDistance.ToString();
            tbb0a1.Text = Matrix.b0a1.MaxDistance.ToString();
            tbb0b1.Text = Matrix.b0b1.MaxDistance.ToString();
        
        }

        private void FeatureMatrixComparator_Shown(object sender, EventArgs e)
        {
            this.SetControlsValues();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            /*
            Matrix.ComparisonMatrix[0][0].SignedDistance = cba0a1.Checked;
            Matrix.ComparisonMatrix[0][1].SignedDistance = cba0b1.Checked;
            Matrix.ComparisonMatrix[1][0].SignedDistance = cbb0a1.Checked;
            Matrix.ComparisonMatrix[1][1].SignedDistance = cbb0b1.Checked;
            Matrix.ComparisonMatrix[0][0].MaxDistance = Double.Parse(tba0a1.Text);
            Matrix.ComparisonMatrix[0][1].MaxDistance = Double.Parse(tba0b1.Text);
            Matrix.ComparisonMatrix[1][0].MaxDistance = Double.Parse(tbb0a1.Text);
            Matrix.ComparisonMatrix[1][1].MaxDistance = Double.Parse(tbb0b1.Text);
            */
            Matrix.a0a1.SignedDistance = cba0a1.Checked;
            Matrix.a0b1.SignedDistance = cba0b1.Checked;
            Matrix.b0a1.SignedDistance = cbb0a1.Checked;
            Matrix.b0b1.SignedDistance = cbb0b1.Checked;
            Matrix.a0a1.MaxDistance = Double.Parse(tba0a1.Text);
            Matrix.a0b1.MaxDistance = Double.Parse(tba0b1.Text);
            Matrix.b0a1.MaxDistance = Double.Parse(tbb0a1.Text);
            Matrix.b0b1.MaxDistance = Double.Parse(tbb0b1.Text);
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void buttonReset_Click(object sender, EventArgs e)
        {
            Matrix.SetDefaultValues();
            this.SetControlsValues();
        }
    }
}
