﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Agora.Model.ImageAnalysis;
using Agora.Model.Utils;
using Agora.Model.OperatorLevel0;
using Agora.Model.OperatorLevel0.Pairing;
using Agora.Model.OperatorLevel1;

namespace GUI.L1Operations
{
    public partial class SetFeatures : Form
    {
        /// <summary>
        /// Properties to set before showing form
        /// </summary>
        public List<string> Labels { get; set; }
        public int NbDimensions { get; set; }

        /// <summary>
        /// Properties to get after closing form
        /// </summary>
        public Agora.Model.OperatorLevel1.CSetFeatures Operator { get; set; }

        public SetFeatures()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.None;
            Labels = new List<string>();
        }
        private void SetDefaultPropertiesValues()
        {
            Operator.EOCTypeChild = this.Labels[0];
            Operator.EOCTypeParent = this.Labels[0];
            Operator.Modes = CFeatureMode.BuildArray(NbDimensions);
        }
        private void SetControlsValues()
        {
            // Labels
            cbParentLabel.Items.Clear();
            cbEOCToSetFeaturesLabel.Items.Clear();
            foreach (string label in Labels)
            {
                cbParentLabel.Items.Add(label);
                cbEOCToSetFeaturesLabel.Items.Add(label);
            }
            cbEOCToSetFeaturesLabel.SelectedItem = Operator.EOCTypeChild;
            cbParentLabel.SelectedItem = Operator.EOCTypeParent;
        }
        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Operator.EOCTypeParent = String.Copy(cbParentLabel.SelectedItem.ToString());
            Operator.EOCTypeChild = String.Copy(cbEOCToSetFeaturesLabel.SelectedItem.ToString());
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void SetFeatures_Shown(object sender, EventArgs e)
        {
            if (Operator.EOCTypeChild == null) SetDefaultPropertiesValues();
            if (Operator.EOCTypeParent == null) SetDefaultPropertiesValues();
            if (Operator.Modes == null) SetDefaultPropertiesValues();
            SetControlsValues();
        }

        private void buttonSetFeaturesModes_Click(object sender, EventArgs e)
        {
            GUI.L1Operations.FeatureMode frm = new GUI.L1Operations.FeatureMode();
            frm.NbDimensions = this.NbDimensions;
            frm.Modes = Operator.Modes;
            frm.ShowDialog();
            if (frm.DialogResult == DialogResult.OK)
            {
            }
        }
    }
}
