﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GUI.MiscOperations
{
    public partial class ExportResults : Form
    {
        /// <summary>
        /// Properties to set before showing form
        /// </summary>
        public List<string> Labels { get; set; }

        /// <summary>
        /// Properties to get after closing form
        /// </summary>
        public List<string> LabelsAltoString { get; set; }
        public List<string> LabelsAltoWord { get; set; }
        public List<string> LabelsAltoLine { get; set; }
        public List<string> LabelsAltoBlock { get; set; }
        public List<string> LabelsAltoIllustration { get; set; }
        public bool AltoGenerateThumbnails { get; set; }
        public bool AltoThumbnailsJPEGFormat { get; set; }
        public bool AltoThumbnailsPrefixOriginalFilename { get; set; }

        public ExportResults()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.None;
            Labels = new List<string>();
            LabelsAltoString = new List<string>();
            LabelsAltoWord = new List<string>();
            LabelsAltoLine = new List<string>();
            LabelsAltoBlock = new List<string>();
            LabelsAltoIllustration = new List<string>();
            AltoGenerateThumbnails = false;
            AltoThumbnailsJPEGFormat = false;
            AltoThumbnailsPrefixOriginalFilename = false;
        }

        private void ExportResults_Shown(object sender, EventArgs e)
        {
            foreach (string label in Labels)
            {
                clbxLabelsAltoBlock.Items.Add(label);
                clbxLabelsAltoIllustration.Items.Add(label);
                clbxLabelsAltoLine.Items.Add(label);
                clbxLabelsAltoString.Items.Add(label);
                clbxLabelsAltoWord.Items.Add(label);
            }
            cbxGenerateThumbnails.Checked = false;
            cbxThumbnailsJPEGFormat.Checked = false;
            cbxThumbnailsJPEGFormat.Enabled = false;
            cbxPrefixOriginalFilename.Checked = false;
            cbxPrefixOriginalFilename.Enabled = false;
        }

        private void GetCheckedItems(List<string> list, CheckedListBox clbx)
        {
            list.Clear();
            for (int i = 0; i < clbx.CheckedItems.Count; i++)
            {
                list.Add(clbx.CheckedItems[i].ToString());
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.GetCheckedItems(LabelsAltoBlock, clbxLabelsAltoBlock);
            this.GetCheckedItems(LabelsAltoIllustration, clbxLabelsAltoIllustration);
            this.GetCheckedItems(LabelsAltoLine, clbxLabelsAltoLine);
            this.GetCheckedItems(LabelsAltoString, clbxLabelsAltoString);
            this.GetCheckedItems(LabelsAltoWord, clbxLabelsAltoWord);
            AltoGenerateThumbnails = cbxGenerateThumbnails.Checked;
            AltoThumbnailsJPEGFormat = cbxThumbnailsJPEGFormat.Checked;
            AltoThumbnailsPrefixOriginalFilename = cbxPrefixOriginalFilename.Checked;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void cbxGenerateThumbnails_CheckedChanged(object sender, EventArgs e)
        {
            cbxThumbnailsJPEGFormat.Enabled = cbxGenerateThumbnails.Checked;
            cbxPrefixOriginalFilename.Enabled = cbxGenerateThumbnails.Checked;
        }

    }
}
