﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;

using Agora.ViewModel;

namespace TestClassifyByPosition
{
    class Program
    {
        static void Main(string[] args)
        {
            Trace.Listeners.Clear();
            Trace.Listeners.Add(new ConsoleTraceListener(false));
            CViewModel vm = new CViewModel();
            vm.ProjectSetProjectDirectory(AppDomain.CurrentDomain.BaseDirectory);
            vm.ProjectSetImagesSubDirectory(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"));
            vm.ProjectSelectCurrentImage(Path.Combine(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"), "sizes01.png"));

            vm.MiscOperatorCreateLabel.EOCTypeName = "CC";
            vm.MiscCreateLabel();
            vm.MiscOperatorCreateLabel.EOCTypeName = "CHAR";
            vm.MiscCreateLabel();

            vm.L1OperatorFindCC.EOCTypeParent = "DOCUMENT";
            vm.L1OperatorFindCC.EOCTypeNewCC = "CC";
            vm.L1FindCC();

            vm.L2OperatorClassifyByFeatures.EOCTypeParent = "DOCUMENT";
            vm.L2OperatorClassifyByFeatures.EOCTypeChild = "CC";
            vm.L2OperatorClassifyByFeatures.EOCTypeNewEOC = "CHAR";
            vm.L2OperatorClassifyByFeatures.ChildFeatures = new Agora.Model.ImageAnalysis.CFeatures(
                new double[] { 20, 5, 0, 0, 0 },
                new double[] { 30, 15, 0, 0, 0 });
            vm.L2OperatorClassifyByFeatures.Coefficients = new double[][] {
                new double[]{1,1,0,0,0}};
            vm.L2OperatorClassifyByFeatures.Comparator = new Agora.Model.OperatorLevel0.Pairing.CFeaturesComparator(vm.AnalysisGetDimensions().Length);
            /*
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].ComparisonMatrix[0][0].MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].ComparisonMatrix[1][1].MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].ComparisonMatrix[0][0].MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].ComparisonMatrix[1][1].MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Type = Agora.Model.OperatorLevel2.CClassifyByFeatures.ClassificationType.ClassifyByPosition;
            */
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].a0a1.MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].b0b1.MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].a0a1.MaxDistance = 5;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].b0b1.MaxDistance = 5;
            vm.L2ClassifyByFeatures();

            vm.AnalysisGenerateDebugImage("debug01.png", new List<string>(new string[] { "CHAR" }));

            vm.ProjectScenarioSave("scen01.xml");
            vm.ProjectSave("proj01.xml");
            vm.ProjectOpen("proj01.xml");
        }
    }
}
