﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;

using Agora.ViewModel;

namespace TestClassifyBySize
{
    class Program
    {
        static void Main(string[] args)
        {
            Trace.Listeners.Clear();
            Trace.Listeners.Add(new ConsoleTraceListener(false));
            CViewModel vm = new CViewModel();
            vm.ProjectSetProjectDirectory(AppDomain.CurrentDomain.BaseDirectory);
            vm.ProjectSetImagesSubDirectory(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"));
            vm.ProjectSelectCurrentImage(Path.Combine(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"), "sizes01.png"));

            vm.MiscOperatorCreateLabel.EOCTypeName = "CC";
            vm.MiscCreateLabel();
            vm.MiscOperatorCreateLabel.EOCTypeName = "CHAR";
            vm.MiscCreateLabel();

            vm.L1OperatorFindCC.EOCTypeParent = "DOCUMENT";
            vm.L1OperatorFindCC.EOCTypeNewCC = "CC";
            vm.L1FindCC();

            vm.L2OperatorClassifyByFeatures.EOCTypeParent = "DOCUMENT";
            vm.L2OperatorClassifyByFeatures.EOCTypeChild = "CC";
            vm.L2OperatorClassifyByFeatures.EOCTypeNewEOC = "CHAR";
            vm.L2OperatorClassifyByFeatures.ChildFeatures = new Agora.Model.ImageAnalysis.CFeatures(
                new double[] { 0, 0, 0, 0, 0 },
                new double[] { 10, 10, 0, 0, 0 });
            vm.L2OperatorClassifyByFeatures.Coefficients = new double[][] {
                new double[]{1,1,0,0,0}};
            vm.L2OperatorClassifyByFeatures.Comparator = new Agora.Model.OperatorLevel0.Pairing.CFeaturesComparator(vm.AnalysisGetDimensions().Length);
            /*
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].ComparisonMatrix[0][0].MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].ComparisonMatrix[1][1].MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].ComparisonMatrix[0][0].MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].ComparisonMatrix[1][1].MaxDistance = 2;
            */
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].a0a1.MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[0].b0b1.MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].a0a1.MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Comparator.Comparators[1].b0b1.MaxDistance = 2;
            vm.L2OperatorClassifyByFeatures.Type = Agora.Model.OperatorLevel2.CClassifyByFeatures.ClassificationType.ClassifyBySize;
            vm.L2ClassifyByFeatures();

            vm.AnalysisGenerateDebugImage("debug01.png", new List<string>(new string[] { "CHAR" }));

            vm.ProjectScenarioSave("scen01.xml");
            vm.ProjectSave("proj01.xml");
            vm.ProjectOpen("proj01.xml");
            /*
            CPattern p;
            COperator op;

            analysis.CreateEOCType(CEOCType.EOCCC, CEOCType.EOCCCName);
            analysis.CreateEOCType(CEOCType.EOCNoise, CEOCType.EOCNoiseName);
            analysis.CreateEOCType(CEOCType.EOCChar, CEOCType.EOCCharName);
            analysis.CreateEOCType(CEOCType.EOCWord, CEOCType.EOCWordName);

            Trace.WriteLine("Find CC...");
            p = new CPattern(analysis.GetEOCTypeByID(CEOCType.EOCCC));
            p.LoadPatternSingle(analysis.GetEOCTypeByID(CEOCType.EOCDocument));
            op = new CFindCC(p);
            op.Apply(analysis.Graph.GetRoot());
            Trace.WriteLine(" OK");

            Trace.WriteLine("Classify Noise...");
            p = new CPattern(analysis.GetEOCTypeByID(CEOCType.EOCNoise));
            p.LoadPatternSize(
                analysis.GetEOCTypeByID(CEOCType.EOCDocument),
                analysis.GetEOCTypeByID(CEOCType.EOCCC),
                new double[] { 2.0, 2.0, 0.0, 0.0 },
                new double[][] { new double[] { 1.0, 1.0, 0.0, 0.0 } },
                new double[] { 2.5 },
                CPattern.SetPointMode.ChildsAverage);
            op = new COperatorInsert(p);
            op.Apply(analysis.Graph.GetRoot());
            Trace.WriteLine(" OK");

            Trace.WriteLine("Delete Noise...");
            p = new CPattern(analysis.GetEOCTypeByID(CEOCType.EOCNoType));
            p.LoadPatternSingleChild(
                analysis.GetEOCTypeByID(CEOCType.EOCNoType),
                analysis.GetEOCTypeByID(CEOCType.EOCNoise));
            op = new COperatorDelete(p, true);
            op.Apply(analysis.Graph.GetRoot());
            Trace.WriteLine(" OK");

            Trace.WriteLine("Classify Char...");
            p = new CPattern(analysis.GetEOCTypeByID(CEOCType.EOCChar));
            p.LoadPatternSize(
                analysis.GetEOCTypeByID(CEOCType.EOCDocument),
                analysis.GetEOCTypeByID(CEOCType.EOCCC),
                new double[] { 30.0, 30.0, 0.0, 0.0 },
                new double[][] { new double[] { 1.0, 0.5, 0.0, 0.0 } },
                new double[] { 25.0 },
                CPattern.SetPointMode.ChildsAverage);
            op = new COperatorInsert(p);
            op.Apply(analysis.Graph.GetRoot());
            Trace.WriteLine(" OK");

            Bitmap bm = new Bitmap(analysis.CurrentImage);
            Graphics g = Graphics.FromImage(bm);
            Pen pen = new Pen(Color.FromKnownColor(KnownColor.Black));
            pen.Width = 1.0F;
            KnownColor[] colors = new KnownColor[] {
                KnownColor.Black,
                KnownColor.White,
                KnownColor.Green, // CC
                KnownColor.Aqua,   // Noise
                KnownColor.Yellow, // Char
                KnownColor.Red, 
                KnownColor.Blue, // Word
                KnownColor.Red // Line
                };

            SortedList<int, List<CEOC>> eocTbl = new SortedList<int, List<CEOC>>();

            CBFS bfs = new CBFS();
            bfs.Start(analysis.Graph.GetRoot());
            CEOC eoc = bfs.GetNext();
            while (eoc != null)
            {
                if (!eocTbl.ContainsKey(eoc.Eoctype.Type))
                {
                    eocTbl.Add(eoc.Eoctype.Type, new List<CEOC>());
                }
                eocTbl[eoc.Eoctype.Type].Add(eoc);
                eoc = bfs.GetNext();
            }
            foreach (KeyValuePair<int, List<CEOC>> pair in eocTbl)
            {
                foreach (CEOC e in pair.Value)
                {
                    //Console.WriteLine(e.boundingBox.ToString());
                    pen.Color = Color.FromKnownColor(colors[e.Eoctype.Type]);
                    g.DrawRectangle(pen, e.BoundingBox);
                }
            }
            pen.Dispose();
            bm.Save("debug01.jpg");
             * */
        }
    }
}
