﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;

using Agora.ViewModel;

namespace TestFusion
{
    class Program
    {
        static void Main(string[] args)
        {
            Trace.Listeners.Clear();
            Trace.Listeners.Add(new ConsoleTraceListener(false));
            CViewModel vm = new CViewModel();
            vm.ProjectSetProjectDirectory(AppDomain.CurrentDomain.BaseDirectory);
            vm.ProjectSetImagesSubDirectory(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"));
            vm.ProjectSelectCurrentImage(Path.Combine(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"), "mots01.png"));

            vm.MiscOperatorCreateLabel.EOCTypeName = "CC";
            vm.MiscCreateLabel();
            vm.MiscOperatorCreateLabel.EOCTypeName = "WORD";
            vm.MiscCreateLabel();

            vm.L1OperatorFindCC.EOCTypeParent = "DOCUMENT";
            vm.L1OperatorFindCC.EOCTypeNewCC = "CC";
            vm.L1FindCC();

            // W <- W + W
            vm.L2OperatorFusion.EOCTypeParent = "DOCUMENT";
            vm.L2OperatorFusion.EOCTypeChilds = "CC";
            vm.L2OperatorFusion.EOCTypeNewEOC = "WORD";
            vm.L2OperatorFusion.Comparator = new Agora.Model.OperatorLevel0.Pairing.CFeaturesComparator(vm.AnalysisGetDimensions().Length);
            //vm.L2OperatorFusion.Comparator.Comparators[0].ComparisonMatrix[1][0].MaxDistance = 20;
            vm.L2OperatorFusion.Comparator.Comparators[0].b0a1.MaxDistance = 20;
            vm.L2OperatorFusion.Neighbouroud = null;
            vm.L2OperatorFusion.Modes = Agora.Model.ImageAnalysis.CFeatureMode.BuildArray(vm.AnalysisGetDimensions().Length);
            vm.L2Fusion();

            vm.AnalysisGenerateDebugImage("debug01.png", new List<string>(new string[] { "WORD" }));

            vm.ProjectScenarioSave("scen01.xml");
            vm.ProjectSave("proj01.xml");
            vm.ProjectOpen("proj01.xml");
        }
    }
}
