﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Diagnostics;

using Agora.ViewModel;
using Agora.Model.ImageAnalysis;
using Agora.Model.OperatorLevel0.Pairing;

namespace TestInsert
{
    class Program
    {
        static void Main(string[] args)
        {
            Trace.Listeners.Clear();
            Trace.Listeners.Add(new ConsoleTraceListener(false));
            CViewModel vm = new CViewModel();
            vm.ProjectSetProjectDirectory(AppDomain.CurrentDomain.BaseDirectory);
            vm.ProjectSetImagesSubDirectory(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"));
            vm.ProjectSelectCurrentImage(Path.Combine(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "images"), "mots01.png"));

            vm.MiscOperatorCreateLabel.EOCTypeName = "CC";
            vm.MiscCreateLabel();
            vm.MiscOperatorCreateLabel.EOCTypeName = "WORD";
            vm.MiscCreateLabel();

            vm.L1OperatorFindCC.EOCTypeParent = "DOCUMENT";
            vm.L1OperatorFindCC.EOCTypeNewCC = "CC";
            vm.L1FindCC();

            // W <- CC + CC
            vm.L1OperatorInsert.EOCTypeParent = "DOCUMENT";
            vm.L1OperatorInsert.EOCTypeNewEOC = "WORD";
            vm.L1OperatorInsert.EOCTypeChilds = new string[] { "CC", "CC" };
            vm.L1OperatorInsert.Features = CFeatures.BuildArray(2, vm.AnalysisGetDimensions().Length);
            vm.L1OperatorInsert.Evaluator.PatternGraphComparators = null;
            vm.L1OperatorInsert.Evaluator.GraphGraphComparators = CFeaturesComparator.BuildMatrix(2, 5);
            //vm.L1OperatorInsert.Evaluator.GraphGraphComparators[0][1].Comparators[0].ComparisonMatrix[0][1].MaxDistance = 10;
            vm.L1OperatorInsert.Evaluator.GraphGraphComparators[0][1].Comparators[0].a0b1.MaxDistance = 10;
            vm.L1OperatorInsert.Evaluator.EnableRotation = false;
            vm.L1OperatorInsert.Evaluator.EnableScaling = false;
            vm.L1OperatorInsert.Evaluator.EnableTranslation = false;
            vm.L1OperatorInsert.Evaluator.Coefficients = new double[][] { new double[5] };
            vm.L1OperatorInsert.Neighbouroud = null;
            vm.L1OperatorInsert.Modes = CFeatureMode.BuildArray(vm.AnalysisGetDimensions().Length);
            vm.L1OperatorInsert.Loop = false;
            vm.L1Insert();

            vm.AnalysisGenerateDebugImage("debug01.png", new List<string>(new string[] { "WORD" }));

            vm.ProjectScenarioSave("scen01.xml");
            vm.ProjectSave("proj01.xml");
            vm.ProjectOpen("proj01.xml");
        }
    }
}
