﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

using Agora.Model.Project;
using Agora.Model.ImageAnalysis;
using Agora.Model.OperatorLevel0;
using Agora.Model.OperatorLevel0.Pairing;
using Agora.Model.OperatorLevel1;
using Agora.Model.OperatorMisc;

namespace TestScenarioXML
{
    class Program
    {
        static void Main(string[] args)
        {
            CScenarioStep st;
            CScenario scen = new CScenario();
            scen.Dimensions = new int[] {1,2,3,4};
            scen.Init(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "sizes01.jpg"));
            CCreateLabel op1 = new CCreateLabel("CHILD");
            st = new CScenarioStep(op1);
            scen.AddStep(st);
            CCreateLabel op2 = new CCreateLabel("NEW");
            st = new CScenarioStep(op2);
            scen.AddStep(st);
            CClassify op = new CClassify();
            op.ChildFeatures = new CFeatures(new double[] { 0, 0, 0, 0 }, new double[] { 1, 2, 3, 4 });
            op.Comparator = new CFeaturesComparator(4);
            op.Coefficients = new double[][]{ new double[] { 1, 1, 1, 1 }};
            op.EOCTypeChild = "CHILD";
            op.EOCTypeNewEOC = "NEW";
            op.EOCTypeParent = "DOCUMENT";
            op.Type = CClassify.ClassificationType.ClassifyByPosition;
            st = new CScenarioStep(op);
            scen.AddStep(st);
            scen.Save(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "s01.xml"));

            CScenario verif = CScenario.Load(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "s01.xml"));
        }
    }
}
